Running "Turbo C" on the IBM PCjr
Lee Johnson [71310,405]
29 May 1987

The following outlines the procedure for patching the "Integrated
Development Environment" of Borland International's "Turbo C" program
so that it will run on a PCjr.

Disclaimer:  You undertake this patch at your own risk.  I will not assume
any liability for damages incurred as a direct or indirect result of the
use of the patch.

Now, on with the show!  You will need:

- A PCjr with at least 384K of memory and one disk drive.

- Your (legitimate) copy of the Turbo C "Integrated Development Environment"
  disk.  This is the disk which contains the file TC.EXE.  (From here on in,
  I will simply call this disk the "TC disk".)

- One or more blank disks.  You will need more than one if you want to
  back up the patched TC disk.

- The DEBUG and DISKCOPY programs, which come with your DOS disks.

Procedure (assuming a one-drive system):

1.	Using DISKCOPY, copy the TC disk to a blank disk.  Put your original
	disk away; we will be applying the patch to the backup copy.

2.	At the DOS prompt, type:

		rename tc.exe tc.xxx
		b:debug tc.xxx

	When DOS asks you to insert the diskette for drive B:, insert the disk
	containing the DEBUG program, then press any key.  After some disk
	activity, DOS will ask you to insert the diskette for drive A:.  Insert
	the copy of the TC disk, then press any key.  After some disk activity,
	DEBUG will indicate readiness by displaying a hyphen ('-').

3.	Now type:

		r

	DEBUG will display the current contents of the processor's registers.
	The display may look something like this:

	AX=0000  BX=0003  CX=8759  DX=0000  SP=FFEE  BP=0000  SI=0000  DI=0000
	DS=0FE7  ES=0FE7  SS=0FE7  CS=0FE7  IP=0100   NV UP DI PL NZ NA PO NC
	0FE7:0100 4D            DEC     BP
	-

	Some of the values you see may be different than the ones shown here.
	Look at BX and CX.  BX must equal 0003 and CX must equal 8759.  If the
	values you see are different, then you possibly have a different version
	of the program, and the patch may not work.  (This patch is written for
	Turbo C version 1.0.)

4.  Get a piece of paper and write down the value for the DS register.
	Now add 3000 (hex) to that value.  If you aren't familiar with
	hexadecimal arithmetic, the following short table may help. (Replace
	"xyz" with the last 3 digits of the value of DS.)

		0xyz + 3000 = 3xyz
		1xyz + 3000 = 4xyz
		2xyz + 3000 = 5xyz
		3xyz + 3000 = 6xyz
		4xyz + 3000 = 7xyz
		5xyz + 3000 = 8xyz
		6xyz + 3000 = 9xyz
		7xyz + 3000 = Axyz
		8xyz + 3000 = Bxyz
		9xyz + 3000 = Cxyz
		Axyz + 3000 = Dxyz
		Bxyz + 3000 = Exyz
		Cxyz + 3000 = Fxyz

	In our example above, 0FE7 + 3000 = 3FE7.

5.	Let "xxxx" be the result of the calculation in step 4.  From now on,
	if you are asked to type "xxxx" as part of a command, it means to
	type the result of the calculation in step 4.  Type:

		dxxxx:42d

	(Using our example, we would type "d3fe7:42d").  DEBUG will display
	something like:

	xxxx:042D  3C 03 75
	xxxx:0430  03 E9 AB 00 88 45 01 B4-0F CD 10 88 65 04 C6 45

	(Users of DOS 3.x may have the numbers formatted slightly differently.)
	There will be some characters display near the right edge of the
	screen; these are unimportant.  What is important is that the
	numbers on your screen agree with the ones shown above (except for
	"xxxx".)  If your numbers disagree, check your work from steps 4 and 5
	to make sure it is correct.  If necessary, try steps 4 and 5 over
	again.  If your numbers still disagree, you may have a different
	version of the program, and the patch will not work.

6.	Type the following DEBUG command, taking great care not to make any
	mistakes:

		fxxxx:42dL7 90

	Now type:

		uxxxx:42dL8

	DEBUG should display something like:

	xxxx:042D 90            NOP
	xxxx:042E 90            NOP
	xxxx:042F 90            NOP
	xxxx:0430 90            NOP
	xxxx:0431 90            NOP
	xxxx:0432 90            NOP
	xxxx:0433 90            NOP
	xxxx:0434 884501        MOV     [DI+01],AL

	If you don't get this result, you have done something wrong.  Go back
	and check your work; Start over if necessary.

7.	Enter:

		w

	DEBUG will respond:

	Writing 38759 bytes

	Now enter

		q

	You should now see your DOS prompt.

8.	Enter the DOS command:

		rename tc.xxx tc.exe

	Congratulations!  You now have a version of TC.EXE that runs on a
	PCjr.  If you wish, now would be a good time to back up the patched
	TC disk.  Put one of the patched copies away with the original disk.

NOTES:

There appears to have been a deliberate effort on the part of Turbo C's
implementor(s) to exclude the PCjr.  TC.EXE *seems* to work with the patch
in place, although it is possible that there some surprise lurks down the
road for PCjr users.  I can only assume that the developers had a good
reason for not wanting TC to run on the PCjr.  My theory is that Turbo C
was fixed so that it would not run on the PCjr so that Borland would not
have to support Turbo C's use on the jr.  However, there may be purely
technical reasons why Turbo C doesn't or shouldn't run on the jr.

Keep in mind that since Turbo C is not advertised as running on the PCjr,
Borland will probably reserve the right to deny support to PCjr Turbo C
users.  This patch is strictly use-at-your-own-risk.

FEEDBACK:

If you liked this patch, tell me about it!  You can EPlex me at [71310,405].
Likewise, send any corrections to me at that address.

Regards,
Lee Johnson
